
--[[ =======================================================================

	Custom Unit Commands - Definitions

		Data and callbacks for enabling custom unit commands to appear and 
		work in the Unit Panel UI. These definitions mimic what appears in 
		data for common unit commands, and are used in the replacement 
		UnitPanel script.

-- =========================================================================]]

m_ModUnitCommands = {};

m_ModUnitCommands.ADVANCED_SLEEP = {};

-- Command State Properties
m_ModUnitCommands.ADVANCED_SLEEP.Properties = {};

-- Command UI Data
m_ModUnitCommands.ADVANCED_SLEEP.EventName		= "ModCommand_AdvancedSleep";
m_ModUnitCommands.ADVANCED_SLEEP.CategoryInUI	= "INPLACE";
m_ModUnitCommands.ADVANCED_SLEEP.Icon			= "ICON_UNITOPERATION_SKIP_TURN";
m_ModUnitCommands.ADVANCED_SLEEP.ToolTipString	= Locale.Lookup("LOC_UNITCOMMAND_ADVANCED_SLEEP_DESCRIPTION");
m_ModUnitCommands.ADVANCED_SLEEP.DisabledToolTipString = Locale.Lookup("LOC_UNITCOMMAND_ADVANCED_SLEEP_DISABLED_TT");
m_ModUnitCommands.ADVANCED_SLEEP.VisibleInUI	= true;

-- ===========================================================================
function m_ModUnitCommands.ADVANCED_SLEEP.CanUse(pUnit : object)
	print("cucumber");
	if (pUnit == nil) then
		return false;
	end

	return true;
end

-- ===========================================================================
function m_ModUnitCommands.ADVANCED_SLEEP.IsVisible(pUnit : object)
	print("parmesan");
	return pUnit ~= nil and pUnit:GetMovesRemaining() > 0;
end

-- ===========================================================================
function m_ModUnitCommands.ADVANCED_SLEEP.IsDisabled(pUnit : object)
	print("tarte");
	if (pUnit == nil or pUnit:GetMovesRemaining() == 0) then
		return true;
	end

	local iPlotId : number = pUnit:GetPlotId();
	local pPlot : object = Map.GetPlotByIndex(iPlotId);
	if (pPlot == nil) then
		return true;
	end

	return false;
end

